/*---------------------------------------------------------------------------
Program 		:		idesktt	Version 1.1
Author 			:		Michel Leunen
Email 			:		michel@leunen.com
Date 				:		1998
Description :		Hide the ugly colored rectangle under the Desktop Icon Text
//---------------------------------------------------------------------------*/
#include <vcl\vcl.h>
#include <vcl\registry.hpp>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma link "systray"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
   SysTray1->AddIcon();
   SetMenuColors();

   AppReg=new TRegistry;
   AppReg->RootKey=HKEY_CURRENT_USER;
   if(AppReg->OpenKey("Software\\Michel Leunen\\Idesktt",false))
   {
   	try
      {
         ExePath=AppReg->ReadString("ExePath");
         Version=AppReg->ReadString("Version");
         TextColor=AppReg->ReadInteger("TextColor");
      }
      catch (...)
      {
      }
   }
   delete AppReg;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{
	//show window
	ShowWindow(Application->Handle,SW_SHOW);
   Visible=true;
   SetForegroundWindow(Handle);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
	//Hide the application
	ShowWindow(Application->Handle,SW_HIDE);
   Visible=false;
   Action=(TCloseAction)false;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Stop1Click(TObject *Sender)
{
	SysTray1->RemoveIcon();
   delete Bitmap1;
   SaveReg();
   Application->Terminate();	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
	HWND  hwnd;
   hwnd = FindWindow("ProgMan",NULL);
   hwnd = GetWindow(hwnd, GW_CHILD);
   hwnd = GetWindow(hwnd, GW_CHILD);
   if(hwnd)
   {
   	long OldTextColor=::SendMessage(hwnd,LVM_GETTEXTCOLOR,0,0);
   	if(OldTextColor!=TextColor)
   	{
     		::SendMessage(hwnd,LVM_SETTEXTCOLOR,(WPARAM)0,(LPARAM)TextColor);
      	InvalidateRect(hwnd,NULL,TRUE);
   	}
   	if(::SendMessage(hwnd,LVM_GETTEXTBKCOLOR,0,0)!=CLR_NONE)
   	{
   		::SendMessage(hwnd,LVM_SETTEXTBKCOLOR,(WPARAM)0,(LPARAM)CLR_NONE);
	   	InvalidateRect(hwnd,NULL,TRUE);
   	}
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveReg()
{
   Version="1.0";
   ExePath=ExtractFilePath(Application->ExeName);
	AppReg=new TRegistry;
   AppReg->RootKey=HKEY_CURRENT_USER;
   AppReg->LazyWrite=false;
   AppReg->OpenKey("Software\\Michel Leunen\\Idesktt",true);
   try
   {
      AppReg->WriteString("ExePath",ExePath);
   	AppReg->WriteString("Version",Version);
   	AppReg->WriteInteger("TextColor",TextColor);
   }
   catch (...)
   {
   }
   delete AppReg;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::White1Click(TObject *Sender)
{
	TMenuItem *MenuItem=dynamic_cast<TMenuItem *>(Sender);
   if(MenuItem != NULL)
   {
   	switch(MenuItem->Tag)
      {
      	case 0:		TextColor=clWhite;			break;
         case 1:		TextColor=clBlack;			break;
         case 2:		TextColor=clAqua;				break;
         case 3:		TextColor=clBlue;				break;
         case 4:		TextColor=clDkGray;			break;
         case 5:		TextColor=clFuchsia;			break;
         case 6:		TextColor=clGray;				break;
         case 7:		TextColor=clGreen;			break;
         case 8:		TextColor=clLime;				break;
         case 9:		TextColor=clLtGray;			break;
         case 10:		TextColor=clMaroon;			break;
         case 11:		TextColor=clNavy;				break;
         case 12:		TextColor=clOlive;			break;
         case 13:		TextColor=clPurple;			break;
         case 14:		TextColor=clRed;		 		break;
         case 15:		TextColor=clSilver;			break;
         case 16:		TextColor=clTeal;				break;
         case 17:		TextColor=clYellow;			break;
      }
      SaveReg();
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetMenuColors()
{
	//
}
//---------------------------------------------------------------------------

